/*  tds200mt
 *  Copyright (C) 1999 Alvaro De Amicis
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/******************* NOTE *************************************
    the accelerators are from gtk 1.0.x
    (I have commented out them, because 1.2.x doesn't compile)
***************************************************************/


#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "tmt.h"
#include "tmtsig.h"
#include "tmtif.h"

extern CommParam comm_param;
extern GraphOpts graph_options;

GtkWidget *
get_widget (GtkWidget * widget,
			gchar * widget_name)
{
	GtkWidget *found_widget;

	if (widget->parent)
		widget = gtk_widget_get_toplevel (widget);
	found_widget = (GtkWidget *) gtk_object_get_data (GTK_OBJECT (widget),
													  widget_name);
	if (!found_widget)
		g_warning ("Widget not found: %s", widget_name);
	return found_widget;
}

/* This is an internally used function to set notebook tab widgets. */
void
set_notebook_tab (GtkWidget * notebook,
				  gint page_num,
				  GtkWidget * widget)
{
	GtkNotebookPage *page;
	GtkWidget *notebook_page;

	page = (GtkNotebookPage *)
		g_list_nth (GTK_NOTEBOOK (notebook)->children, page_num)->data;
	notebook_page = page->child;
	gtk_widget_ref (notebook_page);
	gtk_notebook_remove_page (GTK_NOTEBOOK (notebook), page_num);
	gtk_notebook_insert_page (GTK_NOTEBOOK (notebook), notebook_page,
							  widget, page_num);
	gtk_widget_unref (notebook_page);
}

GtkWidget *
create_main_window ()
{
	GtkWidget *mwindow;
	GtkWidget *menu;
	GtkWidget *file;
	GtkWidget *menu31;
	GtkWidget *open;
	GtkWidget *save;
	GtkWidget *saveas;
	GtkWidget *sp3;
	GtkWidget *print;
	GtkWidget *sp1;
	GtkWidget *quit;
	GtkWidget *instrument;
	GtkWidget *menu32;
	GtkWidget *sendw;
	GtkWidget *recvw;
	GtkWidget *sp2;
	GtkWidget *sendset;
	GtkWidget *recvset;
	GtkWidget *options;
	GtkWidget *menu33;
/*	GtkWidget *graphics;*/
	GtkWidget *commport;
	GtkWidget *about;
/*	GtkAcceleratorTable *accelerator_table;*/

	mwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (mwindow), "mwindow", mwindow);
	gtk_widget_set_usize (mwindow, 320, 34);
	gtk_signal_connect (GTK_OBJECT (mwindow), "delete_event",
						GTK_SIGNAL_FUNC (closeprogram),
						NULL);
	gtk_signal_connect (GTK_OBJECT (mwindow), "destroy",
						GTK_SIGNAL_FUNC (endprogram),
						NULL);
	gtk_window_set_title (GTK_WINDOW (mwindow), "TDS200");
	gtk_window_set_policy (GTK_WINDOW (mwindow), TRUE, TRUE, FALSE);

	menu = gtk_menu_bar_new ();
	gtk_object_set_data (GTK_OBJECT (mwindow), "menu", menu);
	gtk_widget_show (menu);
	gtk_container_add (GTK_CONTAINER (mwindow), menu);
	gtk_widget_set_usize (menu, -1, 33);
	gtk_container_border_width (GTK_CONTAINER (menu), 2);

	file = gtk_menu_item_new_with_label ("File");
	gtk_object_set_data (GTK_OBJECT (mwindow), "file", file);
	gtk_widget_show (file);
	gtk_container_add (GTK_CONTAINER (menu), file);

	menu31 = gtk_menu_new ();
	gtk_object_set_data (GTK_OBJECT (mwindow), "menu31", menu31);
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (file), menu31);

	open = gtk_menu_item_new_with_label ("Open...");
	gtk_object_set_data (GTK_OBJECT (mwindow), "open", open);
	gtk_widget_show (open);
	gtk_container_add (GTK_CONTAINER (menu31), open);
	gtk_signal_connect (GTK_OBJECT (open), "activate",
						GTK_SIGNAL_FUNC (on_open_activate),
						NULL);
/*	accelerator_table = gtk_accelerator_table_new ();
	gtk_window_add_accelerator_table (GTK_WINDOW (mwindow),
									  accelerator_table);
	gtk_widget_install_accelerator (open, accelerator_table, "activate",
									GDK_O, GDK_CONTROL_MASK);
*/
	save = gtk_menu_item_new_with_label ("Save");
	gtk_object_set_data (GTK_OBJECT (mwindow), "save", save);
	gtk_widget_show (save);
	gtk_container_add (GTK_CONTAINER (menu31), save);
	gtk_signal_connect (GTK_OBJECT (save), "activate",
						GTK_SIGNAL_FUNC (on_save_activate),
						NULL);
/*	gtk_widget_install_accelerator (save, accelerator_table, "activate",
									GDK_S, GDK_CONTROL_MASK);
*/
	saveas = gtk_menu_item_new_with_label ("Save As...");
	gtk_object_set_data (GTK_OBJECT (mwindow), "saveas", saveas);
	gtk_widget_show (saveas);
	gtk_container_add (GTK_CONTAINER (menu31), saveas);
	gtk_signal_connect (GTK_OBJECT (saveas), "activate",
						GTK_SIGNAL_FUNC (on_saveas_activate),
						NULL);

	sp3 = gtk_menu_item_new ();
	gtk_object_set_data (GTK_OBJECT (mwindow), "sp3", sp3);
	gtk_widget_show (sp3);
	gtk_container_add (GTK_CONTAINER (menu31), sp3);

	print = gtk_menu_item_new_with_label ("Print");
	gtk_object_set_data (GTK_OBJECT (mwindow), "print", print);
	gtk_widget_show (print);
	gtk_container_add (GTK_CONTAINER (menu31), print);
	gtk_signal_connect (GTK_OBJECT (print), "activate",
						GTK_SIGNAL_FUNC (on_print_activate),
						mwindow);

	sp1 = gtk_menu_item_new ();
	gtk_object_set_data (GTK_OBJECT (mwindow), "sp1", sp1);
	gtk_widget_show (sp1);
	gtk_container_add (GTK_CONTAINER (menu31), sp1);

	quit = gtk_menu_item_new_with_label ("Quit");
	gtk_object_set_data (GTK_OBJECT (mwindow), "quit", quit);
	gtk_widget_show (quit);
	gtk_container_add (GTK_CONTAINER (menu31), quit);
	gtk_signal_connect (GTK_OBJECT (quit), "activate",
						GTK_SIGNAL_FUNC (on_quit_activate),
						mwindow);

	instrument = gtk_menu_item_new_with_label ("Instrument");
	gtk_object_set_data (GTK_OBJECT (mwindow), "instrument", instrument);
	gtk_widget_show (instrument);
	gtk_container_add (GTK_CONTAINER (menu), instrument);

	menu32 = gtk_menu_new ();
	gtk_object_set_data (GTK_OBJECT (mwindow), "menu32", menu32);
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (instrument), menu32);

	sendw = gtk_menu_item_new_with_label ("Send Waveform...");
	gtk_object_set_data (GTK_OBJECT (mwindow), "sendw", sendw);
	gtk_widget_show (sendw);
	gtk_container_add (GTK_CONTAINER (menu32), sendw);
	gtk_signal_connect (GTK_OBJECT (sendw), "activate",
						GTK_SIGNAL_FUNC (on_sendw_activate),
						NULL);
/*	gtk_widget_install_accelerator (sendw, accelerator_table, "activate",
									GDK_W, GDK_CONTROL_MASK);
*/
	recvw = gtk_menu_item_new_with_label ("Receive Waveform...");
	gtk_object_set_data (GTK_OBJECT (mwindow), "recvw", recvw);
	gtk_widget_show (recvw);
	gtk_container_add (GTK_CONTAINER (menu32), recvw);
	gtk_signal_connect (GTK_OBJECT (recvw), "activate",
						GTK_SIGNAL_FUNC (on_receivew_activate),
						NULL);
/*	gtk_widget_install_accelerator (recvw, accelerator_table, "activate",
									GDK_R, GDK_CONTROL_MASK);
*/
	sp2 = gtk_menu_item_new ();
	gtk_object_set_data (GTK_OBJECT (mwindow), "sp2", sp2);
	gtk_widget_show (sp2);
	gtk_container_add (GTK_CONTAINER (menu32), sp2);

	sendset = gtk_menu_item_new_with_label ("Send Settings...");
	gtk_object_set_data (GTK_OBJECT (mwindow),
						 "sendset", sendset);
	gtk_widget_show (sendset);
	gtk_container_add (GTK_CONTAINER (menu32), sendset);
	gtk_signal_connect (GTK_OBJECT (sendset), "activate",
						GTK_SIGNAL_FUNC (on_sendsett_activate),
						NULL);

	recvset = gtk_menu_item_new_with_label ("Receive Settings");
	gtk_object_set_data (GTK_OBJECT (mwindow),
						 "recvset", recvset);
	gtk_widget_show (recvset);
	gtk_container_add (GTK_CONTAINER (menu32), recvset);
	gtk_signal_connect (GTK_OBJECT (recvset), "activate",
						GTK_SIGNAL_FUNC (on_receivesett_activate),
						NULL);

	options = gtk_menu_item_new_with_label ("Options");
	gtk_object_set_data (GTK_OBJECT (mwindow), "options", options);
	gtk_widget_show (options);
	gtk_container_add (GTK_CONTAINER (menu), options);

	menu33 = gtk_menu_new ();
	gtk_object_set_data (GTK_OBJECT (mwindow), "menu33", menu33);
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (options), menu33);

/*	graphics = gtk_menu_item_new_with_label ("Graphics...");
	gtk_object_set_data (GTK_OBJECT (mwindow), "graphics", graphics);
	gtk_widget_show (graphics);
	gtk_container_add (GTK_CONTAINER (menu33), graphics);
	gtk_signal_connect (GTK_OBJECT (graphics), "activate",
						GTK_SIGNAL_FUNC (on_graphics_activate),
						NULL);
*/
	commport = gtk_menu_item_new_with_label ("Comm Port...");
	gtk_object_set_data (GTK_OBJECT (mwindow), "commport", commport);
	gtk_widget_show (commport);
	gtk_container_add (GTK_CONTAINER (menu33), commport);
	gtk_signal_connect (GTK_OBJECT (commport), "activate",
						GTK_SIGNAL_FUNC (on_commport_activate),
						NULL);

	about = gtk_menu_item_new_with_label ("About...");
	gtk_object_set_data (GTK_OBJECT (mwindow), "about", about);
	gtk_widget_show (about);
	gtk_container_add (GTK_CONTAINER (menu), about);
	gtk_signal_connect (GTK_OBJECT (about), "activate",
						GTK_SIGNAL_FUNC (on_about_activate),
						NULL);
	gtk_menu_item_right_justify (GTK_MENU_ITEM (about));

	return mwindow;
}

GtkWidget *
create_display (GtkWidget **dwgarea)
{
	GtkWidget *display;

	display = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (display), "display", display);
	gtk_widget_set_usize (display, 250, 255);
	gtk_signal_connect (GTK_OBJECT (display), "delete_event",
						GTK_SIGNAL_FUNC (closeprogram),
						NULL);
	gtk_signal_connect (GTK_OBJECT (display), "destroy",
						GTK_SIGNAL_FUNC (endprogram),
						NULL);

	gtk_window_set_title (GTK_WINDOW (display), "untitled");
	gtk_window_set_policy (GTK_WINDOW (display), FALSE, FALSE, FALSE);

	*dwgarea = gtk_drawing_area_new ();

	gtk_object_set_data (GTK_OBJECT (display), "dwgarea", *dwgarea);
	gtk_widget_show (*dwgarea);
	gtk_container_add (GTK_CONTAINER (display), *dwgarea);

	gtk_signal_connect (GTK_OBJECT (*dwgarea), "expose_event",
						GTK_SIGNAL_FUNC (on_dwgarea_expose_event), NULL);
	gtk_signal_connect (GTK_OBJECT (*dwgarea), "configure_event",
						GTK_SIGNAL_FUNC (on_dwgarea_configure_event), NULL);

	return display;
}


GtkWidget *
create_receive_wave ()
{
	GtkWidget *rwave;
	GtkWidget *hbox1;
	GtkWidget *fixed1;
	GtkWidget *frmsrc;
	GtkWidget *vbox1;
	GSList    *vbox1grp = NULL;
	GtkWidget *ch1rb;
	GtkWidget *ch2rb;
	GtkWidget *refarb;
	GtkWidget *refbrb;
	GtkWidget *mathrb;
	GtkWidget *fixed2;
	GtkWidget *vbuttonbox1;
	GtkWidget *receiveb;
	GtkWidget *cancb;

	DialogDataL *ddata;

	ddata = (DialogDataL *) malloc (sizeof (DialogDataL));
	if (ddata == NULL)
		g_error ("Out of memory\n");

	rwave = gtk_window_new (GTK_WINDOW_DIALOG);
	gtk_object_set_data (GTK_OBJECT (rwave), "rwave", rwave);
	gtk_widget_set_usize (rwave, 240, 165);
	gtk_window_set_title (GTK_WINDOW (rwave), "Receive Waveform");
	gtk_window_set_policy (GTK_WINDOW (rwave), FALSE, FALSE, TRUE);

	ddata->wnd = rwave;
	ddata->location = TMT_REFA;

	hbox1 = gtk_hbox_new (FALSE, 0);
	gtk_object_set_data (GTK_OBJECT (rwave), "hbox1", hbox1);
	gtk_widget_show (hbox1);
	gtk_container_add (GTK_CONTAINER (rwave), hbox1);

	fixed1 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (rwave), "fixed1", fixed1);
	gtk_widget_show (fixed1);
	gtk_box_pack_start (GTK_BOX (hbox1), fixed1, FALSE, TRUE, 0);
	gtk_widget_set_usize (fixed1, 120, 165);

	frmsrc = gtk_frame_new ("Source");
	gtk_object_set_data (GTK_OBJECT (rwave), "frmsrc", frmsrc);
	gtk_widget_show (frmsrc);
	gtk_fixed_put (GTK_FIXED (fixed1), frmsrc, 8, 8);
	gtk_widget_set_usize (frmsrc, 59, 137);

	vbox1 = gtk_vbox_new (FALSE, 0);
	gtk_object_set_data (GTK_OBJECT (rwave), "vbox1", vbox1);
	gtk_widget_show (vbox1);
	gtk_container_add (GTK_CONTAINER (frmsrc), vbox1);

	ch1rb = gtk_radio_button_new_with_label (vbox1grp, "Ch 1");
	vbox1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (ch1rb));
	gtk_object_set_data (GTK_OBJECT (rwave), "ch1rb", ch1rb);
	gtk_widget_show (ch1rb);
	gtk_box_pack_start (GTK_BOX (vbox1), ch1rb, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (ch1rb), "toggled",
						GTK_SIGNAL_FUNC (on_rwch1rb_toggled),
						ddata);
	gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (ch1rb), TRUE);

	ch2rb = gtk_radio_button_new_with_label (vbox1grp, "Ch 2");
	vbox1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (ch2rb));
	gtk_object_set_data (GTK_OBJECT (rwave), "ch2rb", ch2rb);
	gtk_widget_show (ch2rb);
	gtk_box_pack_start (GTK_BOX (vbox1), ch2rb, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (ch2rb), "toggled",
						GTK_SIGNAL_FUNC (on_rwch2rb_toggled),
						ddata);

	refarb = gtk_radio_button_new_with_label (vbox1grp, "Ref A");
	vbox1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (refarb));
	gtk_object_set_data (GTK_OBJECT (rwave), "refarb", refarb);
	gtk_widget_show (refarb);
	gtk_box_pack_start (GTK_BOX (vbox1), refarb, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (refarb), "toggled",
						GTK_SIGNAL_FUNC (on_rwrefarb_toggled),
						ddata);

	refbrb = gtk_radio_button_new_with_label (vbox1grp, "Ref B");
	vbox1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (refbrb));
	gtk_object_set_data (GTK_OBJECT (rwave), "refbrb", refbrb);
	gtk_widget_show (refbrb);
	gtk_box_pack_start (GTK_BOX (vbox1), refbrb, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (refbrb), "toggled",
						GTK_SIGNAL_FUNC (on_rwrefbrb_toggled),
						ddata);

	mathrb = gtk_radio_button_new_with_label (vbox1grp, "Math");
	vbox1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (mathrb));
	gtk_object_set_data (GTK_OBJECT (rwave), "mathrb", mathrb);
	gtk_widget_show (mathrb);
	gtk_box_pack_start (GTK_BOX (vbox1), mathrb, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (mathrb), "toggled",
						GTK_SIGNAL_FUNC (on_rwmathrb_toggled),
						ddata);

	fixed2 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (rwave), "fixed2", fixed2);
	gtk_widget_show (fixed2);
	gtk_box_pack_start (GTK_BOX (hbox1), fixed2, FALSE, TRUE, 0);
	gtk_widget_set_usize (fixed2, 120, 165);

	vbuttonbox1 = gtk_vbutton_box_new ();
	gtk_object_set_data (GTK_OBJECT (rwave), "vbuttonbox1", vbuttonbox1);
	gtk_widget_show (vbuttonbox1);
	gtk_fixed_put (GTK_FIXED (fixed2), vbuttonbox1, 16, 16);
	gtk_widget_set_usize (vbuttonbox1, 85, 64);

	receiveb = gtk_button_new_with_label ("Receive");
	gtk_object_set_data (GTK_OBJECT (rwave), "receiveb", receiveb);
	gtk_widget_show (receiveb);
	gtk_container_add (GTK_CONTAINER (vbuttonbox1), receiveb);
	gtk_widget_grab_default (receiveb);
	gtk_signal_connect (GTK_OBJECT (receiveb), "clicked",
						GTK_SIGNAL_FUNC (on_rwreceiveb_clicked),
						ddata);

	cancb = gtk_button_new_with_label ("Cancel");
	gtk_object_set_data (GTK_OBJECT (rwave), "cancb", cancb);
	gtk_widget_show (cancb);
	gtk_container_add (GTK_CONTAINER (vbuttonbox1), cancb);
	gtk_signal_connect (GTK_OBJECT (cancb), "clicked",
						GTK_SIGNAL_FUNC (on_rwcancb_clicked),
						ddata);

/*	gtk_signal_connect_object (GTK_OBJECT (cancb),
*	                         "clicked",
*	                         GTK_SIGNAL_FUNC (gtk_widget_destroy),
*	                         GTK_OBJECT (rwave));
*/
	return rwave;
}


GtkWidget *
create_send_wave ()
{
	GtkWidget *swave;
	GtkWidget *hbox2;
	GtkWidget *fixed3;
	GtkWidget *frmdest;
	GtkWidget *vbox2;
	GSList    *vbox2grp = NULL;
	GtkWidget *refarb;
	GtkWidget *refbrb;
	GtkWidget *fixed4;
	GtkWidget *vbbox2;
	GtkWidget *sendb;
	GtkWidget *cancb;

	DialogDataL *ddata;

	ddata = (DialogDataL *) malloc (sizeof (DialogDataL));
	if (ddata == NULL)
		g_error ("Out of memory\n");

	swave = gtk_window_new (GTK_WINDOW_DIALOG);
	gtk_object_set_data (GTK_OBJECT (swave), "swave", swave);
	gtk_widget_set_usize (swave, 240, 100);
	gtk_window_set_title (GTK_WINDOW (swave), "Send Waveform");
	gtk_window_set_policy (GTK_WINDOW (swave), FALSE, FALSE, FALSE);

	ddata->wnd = swave;
	ddata->location = TMT_REFA;

	hbox2 = gtk_hbox_new (FALSE, 0);
	gtk_object_set_data (GTK_OBJECT (swave), "hbox2", hbox2);
	gtk_widget_show (hbox2);
	gtk_container_add (GTK_CONTAINER (swave), hbox2);

	fixed3 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (swave), "fixed3", fixed3);
	gtk_widget_show (fixed3);
	gtk_box_pack_start (GTK_BOX (hbox2), fixed3, FALSE, TRUE, 0);
	gtk_widget_set_usize (fixed3, 120, 100);

	frmdest = gtk_frame_new ("Destination");
	gtk_object_set_data (GTK_OBJECT (swave), "frmdest", frmdest);
	gtk_widget_show (frmdest);
	gtk_fixed_put (GTK_FIXED (fixed3), frmdest, 8, 8);
	gtk_widget_set_usize (frmdest, 72, 65);

	vbox2 = gtk_vbox_new (FALSE, 0);
	gtk_object_set_data (GTK_OBJECT (swave), "vbox2", vbox2);
	gtk_widget_show (vbox2);
	gtk_container_add (GTK_CONTAINER (frmdest), vbox2);

	refarb = gtk_radio_button_new_with_label (vbox2grp, "Ref A");
	vbox2grp = gtk_radio_button_group (GTK_RADIO_BUTTON (refarb));
	gtk_object_set_data (GTK_OBJECT (swave), "refarb", refarb);
	gtk_widget_show (refarb);
	gtk_box_pack_start (GTK_BOX (vbox2), refarb, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (refarb), "toggled",
						GTK_SIGNAL_FUNC (on_swrefarb_toggled),
						ddata);

	refbrb = gtk_radio_button_new_with_label (vbox2grp, "Ref B");
	vbox2grp = gtk_radio_button_group (GTK_RADIO_BUTTON (refbrb));
	gtk_object_set_data (GTK_OBJECT (swave), "refbrb", refbrb);
	gtk_widget_show (refbrb);
	gtk_box_pack_start (GTK_BOX (vbox2), refbrb, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (refbrb), "toggled",
						GTK_SIGNAL_FUNC (on_swrefbrb_toggled),
						ddata);

	fixed4 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (swave), "fixed4", fixed4);
	gtk_widget_show (fixed4);
	gtk_box_pack_start (GTK_BOX (hbox2), fixed4, FALSE, TRUE, 0);
	gtk_widget_set_usize (fixed4, 120, 80);

	vbbox2 = gtk_vbutton_box_new ();
	gtk_object_set_data (GTK_OBJECT (swave), "vbbox2", vbbox2);
	gtk_widget_show (vbbox2);
	gtk_fixed_put (GTK_FIXED (fixed4), vbbox2, 8, 16);
	gtk_widget_set_usize (vbbox2, 85, 64);

	sendb = gtk_button_new_with_label ("Send");
	gtk_object_set_data (GTK_OBJECT (swave), "sendb", sendb);
	gtk_widget_show (sendb);
	gtk_container_add (GTK_CONTAINER (vbbox2), sendb);
	gtk_signal_connect (GTK_OBJECT (sendb), "clicked",
						GTK_SIGNAL_FUNC (on_swsendb_clicked),
						ddata);

	cancb = gtk_button_new_with_label ("Cancel");
	gtk_object_set_data (GTK_OBJECT (swave), "cancb", cancb);
	gtk_widget_show (cancb);
	gtk_container_add (GTK_CONTAINER (vbbox2), cancb);
	gtk_signal_connect (GTK_OBJECT (cancb), "clicked",
						GTK_SIGNAL_FUNC (on_swcancb_clicked),
						ddata);

/*	gtk_signal_connect_object (GTK_OBJECT (cancb),
*	                         "clicked",
*	                         GTK_SIGNAL_FUNC (gtk_widget_destroy),
*	                          GTK_OBJECT (swave));
*/
	return swave;
}


GtkWidget *
create_comm_setup ()
{
	GtkWidget *cport;
	GtkWidget *hbox4;
	GtkWidget *vbox3;
	GtkWidget *hbox5;
	GtkWidget *label1;
	GtkWidget *cpentry;
	GtkWidget *fixed11;
	GtkWidget *bpsfrm;
	GtkWidget *table1;
	GSList    *table1grp = NULL;
	GtkWidget *c96rb;
	GtkWidget *c192rb;
	GtkWidget *c24rb;
	GtkWidget *c48rb;
	GtkWidget *c6rb;
	GtkWidget *c12rb;
	GtkWidget *fixed12;
	GtkWidget *flfrm;
	GtkWidget *vbox4;
	GSList    *vbox4grp = NULL;
	GtkWidget *ctsrtsrb;
	GtkWidget *xonxoffrb;
	GtkWidget *noflrb;
	GtkWidget *fixed10;
	GtkWidget *vbuttonbox4;
	GtkWidget *okb;
	GtkWidget *cancb;

	DialogData *ddata;
	CommParam *cparam;

	ddata = (DialogData *) malloc (sizeof (DialogData));
	if (ddata == NULL)
		g_error ("Out of memory\n");

	cparam = (CommParam *) malloc (sizeof (CommParam));
	if (cparam == NULL)
		g_error ("Out of memory\n");

	cport = gtk_window_new (GTK_WINDOW_DIALOG);
	gtk_object_set_data (GTK_OBJECT (cport), "cport", cport);
	gtk_widget_set_usize (cport, 280, 250);
	gtk_window_set_title (GTK_WINDOW (cport), "Comm Port");
	gtk_window_set_policy (GTK_WINDOW (cport), FALSE, FALSE, FALSE);

/* comm_param is the global struct that hold serial port configuration */
	*cparam = comm_param;
	ddata->wnd = cport;
	ddata->data = (CommParam*) cparam;

	hbox4 = gtk_hbox_new (FALSE, 0);
	gtk_object_set_data (GTK_OBJECT (cport), "hbox4", hbox4);
	gtk_widget_show (hbox4);
	gtk_container_add (GTK_CONTAINER (cport), hbox4);

	vbox3 = gtk_vbox_new (FALSE, 0);
	gtk_object_set_data (GTK_OBJECT (cport), "vbox3", vbox3);
	gtk_widget_show (vbox3);
	gtk_box_pack_start (GTK_BOX (hbox4), vbox3, TRUE, TRUE, 0);

	hbox5 = gtk_hbox_new (FALSE, 0);
	gtk_object_set_data (GTK_OBJECT (cport), "hbox5", hbox5);
	gtk_widget_show (hbox5);
	gtk_box_pack_start (GTK_BOX (vbox3), hbox5, FALSE, TRUE, 0);
	gtk_widget_set_usize (hbox5, 180, 37);

	label1 = gtk_label_new ("Port");
	gtk_object_set_data (GTK_OBJECT (cport), "label1", label1);
	gtk_widget_show (label1);
	gtk_box_pack_start (GTK_BOX (hbox5), label1, FALSE, TRUE, 0);
	gtk_widget_set_usize (label1, 45, -1);
	gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
	gtk_misc_set_padding (GTK_MISC (label1), 10, 0);

	cpentry = gtk_entry_new ();
	gtk_object_set_data (GTK_OBJECT (cport), "cpentry", cpentry);
	gtk_widget_show (cpentry);
	gtk_box_pack_start (GTK_BOX (hbox5), cpentry, FALSE, TRUE, 0);
	gtk_widget_set_usize (cpentry, 120, 24);
	gtk_entry_set_text (GTK_ENTRY (cpentry), cparam->device);
	gtk_signal_connect (GTK_OBJECT (cpentry), "changed",
						GTK_SIGNAL_FUNC (on_cpentry_activate), ddata);

	fixed11 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (cport), "fixed11", fixed11);
	gtk_widget_show (fixed11);
	gtk_box_pack_start (GTK_BOX (vbox3), fixed11, FALSE, TRUE, 0);
	gtk_widget_set_usize (fixed11, 180, 111);

	bpsfrm = gtk_frame_new ("Bps");
	gtk_object_set_data (GTK_OBJECT (cport), "bpsfrm", bpsfrm);
	gtk_widget_show (bpsfrm);
	gtk_fixed_put (GTK_FIXED (fixed11), bpsfrm, 8, 8);
	gtk_widget_set_usize (bpsfrm, 160, 89);

	table1 = gtk_table_new (3, 2, FALSE);
	gtk_object_set_data (GTK_OBJECT (cport), "table1", table1);
	gtk_widget_show (table1);
	gtk_container_add (GTK_CONTAINER (bpsfrm), table1);

	c96rb = gtk_radio_button_new_with_label (table1grp, "9600");
	table1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (c96rb));
	gtk_object_set_data (GTK_OBJECT (cport), "c96rb", c96rb);
	gtk_widget_show (c96rb);
	gtk_table_attach (GTK_TABLE (table1), c96rb, 0, 1, 2, 3,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
	gtk_widget_set_usize (c96rb, 60, -1);
	gtk_signal_connect (GTK_OBJECT (c96rb), "toggled",
						GTK_SIGNAL_FUNC (on_cp96rb_toggled), ddata);

	c192rb = gtk_radio_button_new_with_label (table1grp, "19200");
	table1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (c192rb));
	gtk_object_set_data (GTK_OBJECT (cport), "c192rb", c192rb);
	gtk_widget_show (c192rb);
	gtk_table_attach (GTK_TABLE (table1), c192rb, 1, 2, 2, 3,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
	gtk_signal_connect (GTK_OBJECT (c192rb), "toggled",
						GTK_SIGNAL_FUNC (on_cp192rb_toggled),
						ddata);

	c24rb = gtk_radio_button_new_with_label (table1grp, "2400");
	table1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (c24rb));
	gtk_object_set_data (GTK_OBJECT (cport), "c24rb", c24rb);
	gtk_widget_show (c24rb);
	gtk_table_attach (GTK_TABLE (table1), c24rb, 0, 1, 1, 2,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
	gtk_signal_connect (GTK_OBJECT (c24rb), "toggled",
						GTK_SIGNAL_FUNC (on_cp24rb_toggled),
						ddata);

	c48rb = gtk_radio_button_new_with_label (table1grp, "4800");
	table1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (c48rb));
	gtk_object_set_data (GTK_OBJECT (cport), "c48rb", c48rb);
	gtk_widget_show (c48rb);
	gtk_table_attach (GTK_TABLE (table1), c48rb, 1, 2, 1, 2,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
	gtk_signal_connect (GTK_OBJECT (c48rb), "toggled",
						GTK_SIGNAL_FUNC (on_cp48rb_toggled),
						ddata);

	c6rb = gtk_radio_button_new_with_label (table1grp, "600");
	table1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (c6rb));
	gtk_object_set_data (GTK_OBJECT (cport), "c6rb", c6rb);
	gtk_widget_show (c6rb);
	gtk_table_attach (GTK_TABLE (table1), c6rb, 0, 1, 0, 1,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
	gtk_widget_set_usize (c6rb, 25, -1);
	gtk_signal_connect (GTK_OBJECT (c6rb), "toggled",
						GTK_SIGNAL_FUNC (on_cp6rb_toggled),
						ddata);

	c12rb = gtk_radio_button_new_with_label (table1grp, "1200");
	table1grp = gtk_radio_button_group (GTK_RADIO_BUTTON (c12rb));
	gtk_object_set_data (GTK_OBJECT (cport), "c12rb", c12rb);
	gtk_widget_show (c12rb);
	gtk_table_attach (GTK_TABLE (table1), c12rb, 1, 2, 0, 1,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL,
					  (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
	gtk_signal_connect (GTK_OBJECT (c12rb), "toggled",
						GTK_SIGNAL_FUNC (on_cp12rb_toggled),
						ddata);

	switch (cparam->bps) {
	case TMT_B6:
		gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c6rb), TRUE);
		break;
	case TMT_B12:
		gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c12rb), TRUE);
		break;
	case TMT_B24:
		gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c24rb), TRUE);
		break;
	case TMT_B48:
		gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c48rb), TRUE);
		break;
	case TMT_B96:
		gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c96rb), TRUE);
		break;
	case TMT_B192:
		gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c192rb), TRUE);
	}

	fixed12 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (cport), "fixed12", fixed12);
	gtk_widget_show (fixed12);
	gtk_box_pack_start (GTK_BOX (vbox3), fixed12, FALSE, TRUE, 0);
	gtk_widget_set_usize (fixed12, 180, 100);

	flfrm = gtk_frame_new ("Flow Control");
	gtk_object_set_data (GTK_OBJECT (cport), "flfrm", flfrm);
	gtk_widget_show (flfrm);
	gtk_fixed_put (GTK_FIXED (fixed12), flfrm, 8, 8);
	gtk_widget_set_usize (flfrm, 160, 89);

	vbox4 = gtk_vbox_new (FALSE, 0);
	gtk_object_set_data (GTK_OBJECT (cport), "vbox4", vbox4);
	gtk_widget_show (vbox4);
	gtk_container_add (GTK_CONTAINER (flfrm), vbox4);

	ctsrtsrb = gtk_radio_button_new_with_label (vbox4grp, "CTS/RTS");
	vbox4grp = gtk_radio_button_group (GTK_RADIO_BUTTON (ctsrtsrb));
	gtk_object_set_data (GTK_OBJECT (cport), "ctsrtsrb", ctsrtsrb);
	gtk_widget_show (ctsrtsrb);
	gtk_box_pack_start (GTK_BOX (vbox4), ctsrtsrb, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (ctsrtsrb), "toggled",
					  GTK_SIGNAL_FUNC (on_cpctsrtsrb_toggled), ddata);

	xonxoffrb = gtk_radio_button_new_with_label (vbox4grp, "Xon/Xoff");
	vbox4grp = gtk_radio_button_group (GTK_RADIO_BUTTON (xonxoffrb));
	gtk_object_set_data (GTK_OBJECT (cport), "xonxoffrb", xonxoffrb);
	gtk_widget_show (xonxoffrb);
	gtk_box_pack_start (GTK_BOX (vbox4), xonxoffrb, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (xonxoffrb), "toggled",
					 GTK_SIGNAL_FUNC (on_cpxonxoffrb_toggled), ddata);

	noflrb = gtk_radio_button_new_with_label (vbox4grp, "none");
	vbox4grp = gtk_radio_button_group (GTK_RADIO_BUTTON (noflrb));
	gtk_object_set_data (GTK_OBJECT (cport), "noflrb", noflrb);
	gtk_widget_show (noflrb);
	gtk_box_pack_start (GTK_BOX (vbox4), noflrb, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (noflrb), "toggled",
					GTK_SIGNAL_FUNC (on_cpnoflowrb_toggled), ddata);

	fixed10 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (cport), "fixed10", fixed10);
	gtk_widget_show (fixed10);
	gtk_box_pack_start (GTK_BOX (hbox4), fixed10, FALSE, TRUE, 0);
	gtk_widget_set_usize (fixed10, 100, -1);

	vbuttonbox4 = gtk_vbutton_box_new ();
	gtk_object_set_data (GTK_OBJECT (cport), "vbuttonbox4", vbuttonbox4);
	gtk_widget_show (vbuttonbox4);
	gtk_fixed_put (GTK_FIXED (fixed10), vbuttonbox4, 8, 8);
	gtk_widget_set_usize (vbuttonbox4, 85, 64);

	okb = gtk_button_new_with_label ("Ok");
	gtk_object_set_data (GTK_OBJECT (cport), "okb", okb);
	gtk_widget_show (okb);
	gtk_container_add (GTK_CONTAINER (vbuttonbox4), okb);
	gtk_signal_connect (GTK_OBJECT (okb), "clicked",
						GTK_SIGNAL_FUNC (on_cpokb_clicked), ddata);

	cancb = gtk_button_new_with_label ("Cancel");
	gtk_object_set_data (GTK_OBJECT (cport), "cancb", cancb);
	gtk_widget_show (cancb);
	gtk_container_add (GTK_CONTAINER (vbuttonbox4), cancb);

	/* gtk_signal_connect (GTK_OBJECT (cancb), "clicked",
	 *                   GTK_SIGNAL_FUNC (on_cpcancb_clicked),
	 *                   NULL);
	 */

	gtk_signal_connect_object (GTK_OBJECT (cancb),
							   "clicked",
							   GTK_SIGNAL_FUNC (gtk_widget_destroy),
							   GTK_OBJECT (cport));

	return cport;
}


GtkWidget *
create_graph_options ()
{
	GtkWidget *go_main;
	GtkWidget *vbox5;
	GtkWidget *fixed13;
	GtkWidget *go_bg_frame;
	GtkWidget *go_bg_chkbutton;
	GtkWidget *fixed14;
	GtkWidget *go_mw_frame;
	GtkWidget *go_mult_chkbutton;
	GtkWidget *fixed15;
	GtkWidget *go_grid_frame;
	GtkWidget *vbox6;
	GSList *vbox6_group = NULL;
	GtkWidget *go_grid_none_rbutton;
	GtkWidget *go_grid_half_rbutton;
	GtkWidget *go_grid_full_rbutton;
	GtkWidget *fixed16;
	GtkWidget *hbuttonbox1;
	GtkWidget *go_ok_button;
	GtkWidget *go_cancel_button;

	DialogData *ddata;
	GraphOpts  *gopts;

	ddata = (DialogData *) malloc (sizeof (DialogData));
	if (ddata == NULL)
		g_error ("Out of memory\n");

	gopts = (GraphOpts *) malloc (sizeof (GraphOpts));
	if (gopts == NULL)
		g_error ("Out of memory\n");

	go_main = gtk_window_new (GTK_WINDOW_DIALOG);
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "go_main",
						 go_main);
	gtk_widget_set_usize (go_main, 220, 240);
	gtk_window_set_title (GTK_WINDOW (go_main), "Graphics Options");
	gtk_window_set_policy (GTK_WINDOW (go_main), FALSE, FALSE, FALSE);

	/* graph_options e' la struttura globale che contiene le opzioni
	   per la visualizzazione grafica */
	*gopts = graph_options;
	ddata->wnd = go_main;
	ddata->data = (GraphOpts*) gopts;

	vbox5 = gtk_vbox_new (FALSE, 0);
	gtk_object_set_data (GTK_OBJECT (go_main), "vbox5", vbox5);
	gtk_widget_show (vbox5);
	gtk_container_add (GTK_CONTAINER (go_main), vbox5);

	fixed13 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (go_main), "fixed13", fixed13);
	gtk_widget_show (fixed13);
	gtk_box_pack_start (GTK_BOX (vbox5), fixed13, FALSE, TRUE, 0);
	gtk_widget_set_usize (fixed13, -1, 48);

	go_bg_frame = gtk_frame_new ("Background");
	gtk_object_set_data (GTK_OBJECT (go_main), "go_bg_frame", go_bg_frame);
	gtk_widget_show (go_bg_frame);
	gtk_fixed_put (GTK_FIXED (fixed13), go_bg_frame, 16, 8);
	gtk_widget_set_usize (go_bg_frame, 184, 40);

	go_bg_chkbutton = gtk_check_button_new_with_label ("Dark color");
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "go_bg_chkbutton",
						 go_bg_chkbutton);
/*	gtk_toggle_button_set_state (GTK_OBJECT (go_bg_chkbutton), gopts->darkbg);*/
	gtk_widget_show (go_bg_chkbutton);
	gtk_container_add (GTK_CONTAINER (go_bg_frame), go_bg_chkbutton);
	gtk_signal_connect (GTK_OBJECT (go_bg_chkbutton), "toggled",
						GTK_SIGNAL_FUNC (on_go_bg_chkbutton_toggled),
						ddata);

	fixed14 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (go_main), "fixed14", fixed14);
	gtk_widget_show (fixed14);
	gtk_box_pack_start (GTK_BOX (vbox5), fixed14, FALSE, TRUE, 0);
	gtk_widget_set_usize (fixed14, -1, 48);

	go_mw_frame = gtk_frame_new ("Multiple waveforms");
	gtk_object_set_data (GTK_OBJECT (go_main), "go_mw_frame", go_mw_frame);
	gtk_widget_show (go_mw_frame);
	gtk_fixed_put (GTK_FIXED (fixed14), go_mw_frame, 16, 8);
	gtk_widget_set_usize (go_mw_frame, 184, 40);

	go_mult_chkbutton = gtk_check_button_new_with_label ("Enable");
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "go_mult_chkbutton",
						 go_mult_chkbutton);
/*	gtk_toggle_button_set_state (GTK_OBJECT (go_mult_chkbutton),
								 gopts->multiwf);
*/	gtk_widget_show (go_mult_chkbutton);
	gtk_container_add (GTK_CONTAINER (go_mw_frame), go_mult_chkbutton);
	gtk_signal_connect (GTK_OBJECT (go_mult_chkbutton), "toggled",
						GTK_SIGNAL_FUNC (on_go_mult_chkbutton_toggled),
						ddata);

	fixed15 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (go_main), "fixed15", fixed15);
	gtk_widget_show (fixed15);
	gtk_box_pack_start (GTK_BOX (vbox5), fixed15, FALSE, TRUE, 0);
	gtk_widget_set_usize (fixed15, -1, 90);

	go_grid_frame = gtk_frame_new ("Grid type");
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "go_grid_frame",
						 go_grid_frame);
	gtk_widget_show (go_grid_frame);
	gtk_fixed_put (GTK_FIXED (fixed15), go_grid_frame, 16, 8);
	gtk_widget_set_usize (go_grid_frame, 184, 80);

	vbox6 = gtk_vbox_new (FALSE, 0);
	gtk_object_set_data (GTK_OBJECT (go_main), "vbox6", vbox6);
	gtk_widget_show (vbox6);
	gtk_container_add (GTK_CONTAINER (go_grid_frame), vbox6);

	go_grid_none_rbutton = gtk_radio_button_new_with_label (vbox6_group, "None");
	vbox6_group = gtk_radio_button_group (GTK_RADIO_BUTTON (go_grid_none_rbutton));
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "go_grid_none_rbutton",
						 go_grid_none_rbutton);
	gtk_widget_show (go_grid_none_rbutton);
	gtk_box_pack_start (GTK_BOX (vbox6), go_grid_none_rbutton, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (go_grid_none_rbutton), "toggled",
						GTK_SIGNAL_FUNC (on_go_grid_none_rbutton_toggled),
						ddata);

	go_grid_half_rbutton = gtk_radio_button_new_with_label (vbox6_group, "Half");
	vbox6_group = gtk_radio_button_group (GTK_RADIO_BUTTON (go_grid_half_rbutton));
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "go_grid_half_rbutton",
						 go_grid_half_rbutton);
	gtk_widget_show (go_grid_half_rbutton);
	gtk_box_pack_start (GTK_BOX (vbox6), go_grid_half_rbutton, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (go_grid_half_rbutton), "toggled",
						GTK_SIGNAL_FUNC (on_go_grid_half_rbutton_toggled),
						ddata);

	go_grid_full_rbutton = gtk_radio_button_new_with_label (vbox6_group, "Full");
	vbox6_group = gtk_radio_button_group (GTK_RADIO_BUTTON (go_grid_full_rbutton));
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "go_grid_full_rbutton",
						 go_grid_full_rbutton);
	gtk_widget_show (go_grid_full_rbutton);
	gtk_box_pack_start (GTK_BOX (vbox6), go_grid_full_rbutton, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (go_grid_full_rbutton), "toggled",
						GTK_SIGNAL_FUNC (on_go_grid_full_rbutton_toggled),
						ddata);

	fixed16 = gtk_fixed_new ();
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "fixed16", fixed16);
	gtk_widget_show (fixed16);
	gtk_box_pack_start (GTK_BOX (vbox5), fixed16, TRUE, TRUE, 0);

	hbuttonbox1 = gtk_hbutton_box_new ();
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "hbuttonbox1",
						 hbuttonbox1);
	gtk_widget_show (hbuttonbox1);
	gtk_fixed_put (GTK_FIXED (fixed16), hbuttonbox1, 16, 16);
	gtk_widget_set_usize (hbuttonbox1, 184, 27);

	go_ok_button = gtk_button_new_with_label ("Ok");
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "go_ok_button",
						 go_ok_button);
	gtk_widget_show (go_ok_button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox1), go_ok_button);
	gtk_signal_connect (GTK_OBJECT (go_ok_button), "clicked",
						GTK_SIGNAL_FUNC (on_go_ok_button_clicked),
						ddata);

	go_cancel_button = gtk_button_new_with_label ("Cancel");
	gtk_object_set_data (GTK_OBJECT (go_main),
						 "go_cancel_button",
						 go_cancel_button);
	gtk_widget_show (go_cancel_button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox1), go_cancel_button);
	/*gtk_signal_connect (GTK_OBJECT (go_cancel_button), "clicked",
	 *                   GTK_SIGNAL_FUNC (on_go_cancel_button_clicked),
	 *                   NULL); */
	gtk_signal_connect_object (GTK_OBJECT (go_cancel_button),
							   "clicked",
							   GTK_SIGNAL_FUNC (gtk_widget_destroy),
							   GTK_OBJECT (go_main));

	return go_main;
}
